#include "turtle3d.h"
#include <GL/glut.h>
#include <iostream>
using namespace std;

const double DEG2RAD = 3.1415926535897932384626433832795/180.0;

turtle3d::turtle3d(double x, double y, double z, double an,double ti, bool d)
   :xpos(x),ypos(y),zpos(z),angle(an),tilt(ti),pen(d),drawing(false),flipfac(1)
   {}

void turtle3d::fixdrawingstate()
{
if(pen && !drawing)
   {
   drawing = true;
   glBegin(GL_LINES);
   }
else if (drawing && !pen)
    {
    glEnd();
    drawing = false;
    }
}

turtle3d & turtle3d::left(const double deg)
{
angle += flipfac*deg;
return *this;
}

turtle3d & turtle3d::right(const double deg)
{
angle -= flipfac*deg;
return *this;
}

turtle3d & turtle3d::up(const double deg)
{
	tilt += flipfac*deg;
	return *this;
}

turtle3d & turtle3d::down(const double deg)
{
	tilt -= flipfac*deg;
	return *this;
}

turtle3d & turtle3d::forward(const double dist)
{
fixdrawingstate();
double oldx = xpos, oldy = ypos, oldz = zpos;

xpos += scale*dist*cos(DEG2RAD*angle)*cos(DEG2RAD*tilt);
ypos += scale*dist*sin(DEG2RAD*angle)*cos(DEG2RAD*tilt);
zpos += scale*dist*sin(DEG2RAD*tilt)*cos(DEG2RAD*angle);
if (drawing)
   {
   glVertex3d(oldx,oldy,oldz);
   glVertex3d(xpos,ypos,zpos);
   }   
return *this;
}

turtle3d & turtle3d::backward(const double dist)
{
return forward(-dist);
}

turtle3d & turtle3d::flip()
{
flipfac *= -1;
return *this;
}

turtle3d & turtle3d::pendown()
{
pen=true;
fixdrawingstate();
return *this;
}

turtle3d & turtle3d::penup()
{
pen=false;
fixdrawingstate();
return *this;
}

turtle3d & turtle3d::finish()
{
if(drawing)
   {
   glEnd();
   drawing = false;
   }
glFinish();
return *this;
}

turtle3d & turtle3d::setpos(const double x, const double y, double z)
{
xpos=x;
ypos=y;
zpos=z;
if (pen && drawing)
    {
    glEnd();
    drawing = false;
    }
fixdrawingstate();

return *this;
}

turtle3d & turtle3d::setang(const double a)
{
angle = a;
return *this;
}

turtle3d & turtle3d::settil(const double t)
{
	tilt = t;
	return *this;
}

turtle3d & turtle3d::setscale(const double s)
{
scale = s;
return *this;
}
