#ifndef turtle3d3D_H
#define turtle3d3D_H

#include <cmath>
#ifdef WIN32
const double M_SQRT2 = 1.414213562;
const double M_PI = 3.1415926535897932384626433832795;
#endif

class turtle3d
{
public:
   turtle3d(double x=0, double y=0, double z=0, double an=0, double ti=0, bool d=true);
   turtle3d & forward(const double);
	turtle3d & backward(const double);
	turtle3d & right(const double);
	turtle3d & left(const double);
	turtle3d & up(const double);
	turtle3d & down(const double);
   turtle3d & penup();
   turtle3d & pendown();
   turtle3d & finish();
   turtle3d & setpos(const double x, const double y, double z);
   turtle3d & setang(const double a);
   turtle3d & settil(const double t);
   turtle3d & setscale(const double s);
   turtle3d & setcutoff(const double c){return *this;}
   turtle3d & flip();
   ~turtle3d(){finish();}
private:
   double xpos;
   double ypos;
   double zpos;
   double angle;
   double tilt;
   double scale;
   double cutoff;
   int flipfac;
   bool pen;
   bool drawing; //between glBegin() and glEnd() ?
   void fixdrawingstate(); //make drawing true if pen is
};
#endif
