#include "turtlecurves3d.h"
#include <iostream>
void tcurve::ward(int l, double d)
{
penup();
forward(d);
right(180);
pendown();
draw(l,d);
penup();
right(180);
forward(d);
pendown();
}

/*
void sierpinski::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=2;
   left(60);
   fdrawf(l,d);
   right(60);
   draw(l,d);
   right(60);
   fdrawf(l,d);
   left(60);
   }
else forward(d);
}
*/

void sierpinski::draw(int l, double d)
{
double dangle = param * 45 + 45;
double rangle = dangle * M_PI / 180;
if(l-- && d >= thresh)
   {
   left(dangle);
   fdrawf(l,d*cos(rangle));
   right(dangle);
   draw(l,d*(1-2*cos(rangle)*cos(rangle)));
   right(dangle);
   fdrawf(l,d*cos(rangle));
   left(dangle);
   }
else forward(d);
}

void koch::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=3;
   draw(l,d);
   left(60);
   draw(l,d);
   right(120);
   draw(l,d);
   left(60);
   draw(l,d);
   }
else forward(d);
}

void koch2::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=3;
   draw(l,d);
   left(60);
   draw(l,d);
   right(120);
   draw(l,d);
   right(120);
   draw(l,d);
   left(120);
   draw(l,d);
   left(120);
   draw(l,d);
   right(60);
   draw(l,d);
   }
else forward(d);
}

/*
void tower::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=3;
   ward(l,d);
   left(120);
   ward(l,d);
   right(120);
   draw(l,2*d);
   right(120);
   ward(l,d);
   left(120);
   ward(l,d);
   }
else forward(d);
}
*/
void tower::draw(int l, double d)
{
double dangle = param * 45 + 45;
double rangle = dangle * M_PI / 180;
if(l-- && d >= thresh)
   {
   left(dangle);
   draw(l,d*cos(rangle));
   right(dangle);
   draw(l,d*(1-2*cos(rangle)*cos(rangle)));
   right(dangle);
   draw(l,d*cos(rangle));
   left(dangle);
   }
else forward(d);
}

void koch8::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=4;
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   draw(l,d);
   left(90);
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   }
else forward(d);
}

void peano::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=3;
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   left(90);
   draw(l,d);
   left(90);
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   }
else
   forward(d);
}

void terdragon::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d /= sqrt(3);
   left(30);
   ward(l,d);
   right(120);
   draw(l,d);
   left(120);
   ward(l,d);
   right(30);
   }
else forward(d);
}

void hshapebottom::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=8;
   draw(l,d*2);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d*4);
   right(90);
   draw(l,d);
   left(90);
   draw(l,d*2);
   }
else forward(d);
}

void dragon::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   float myparam = param*sqrt(3);
   float dangle = atan(myparam)*180/M_PI;
   d*=sqrt(1+myparam*myparam)/2;
   left(dangle);
   draw(l,d);
   right(2*dangle);
   ward(l,d);
   left(dangle);
   }
else forward(d);
}


void test1::atomdraw(int l, double d)
{
   draw(l,d);
   left(120);
   draw(l,d);
   left(120);
   draw(l,d);
   left(120);
}

void test1::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   float angle=param*M_PI/6.0;
   // d/=sqrt(3);
   left(angle*180.0/M_PI);      // cout << "left " << param*180.0/M_PI << endl;
   ward(l,(1/cos(angle))*d/2);  // cout << "ward " << (1/cos(param))*d/2 << endl;
   draw(l,(1/cos(angle))*d/2);  //cout << "draw " << (1/cos(param))*d/2 << endl;
   right(90+angle*180.0/M_PI);  //cout << "right " << 90+param*180.0/M_PI << endl;
   draw(l,tan(angle)*d);        //cout << "draw " << tan(param)*d << endl;
   left(90);
   }
else forward(d);
}

void test2::atomdraw(int l, double d)
{
	draw(l,d);
	right(72);
	draw(l,d);
}

void test2::draw(int l, double d)
{
double dangle = param * 180;
//dangle = acos(-1./8.)*180/M_PI;
double rangle = dangle * M_PI / 180;
double c = cos(rangle);
double rtheta = acos(3*sqrt((1+c)/(10+8*c)));
if(l-- && d >= thresh)
   {
   left((180-dangle)/2);
   ward(l,d*2/3*sin(rangle/2));
   right(90+rtheta*180/M_PI);
   draw(l,d*sqrt(5+4*c)/3);
   left(90+rtheta*180/M_PI);
   ward(l,d*2/3*sin(rangle/2));
   right((180-dangle)/2);
   }
else forward(d);
}

const double dist=.2;

/*void test3::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d /= (sqrt(2)+dist);
   left(45);
   draw(l,d);
   right(45);
   draw(l,d*dist);
   right(45);
   ward(l,d);
   left(45);
   }
else forward(d);
}
*/

void test3::draw(int l, double d)
{

if(l-- && d >= thresh)
   {
   d=(d/3)*sqrt(3);
   up(45);
   draw(l,d);
   down(45);
   right(45);
   
   draw(l,d/2);
   left(90);
   draw(l,d/2);
   right(45);
   down(45);
   draw(l,d);
   up(45);
   
   }
else forward(d);
}


void test4::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=2*sqrt(2);
   left(45);
   draw(l,d);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   draw(l,d);
   left(90);
   draw(l,d);
   left(90);
   draw(l,d);
   draw(l,d);
   right(45);
   }
else forward(d);
}

void test4::ward(int l, double d)
{
if(l-- && d >= thresh)
   {
   d/=M_SQRT2;
   right(45);
   draw(l,d);
   left(90);
   ward(l,d);
   right(45);
   }
else forward(d);
}

void test5::draw(int l, double d)
{
const double dalpha = acos(1./4.) * 180 / M_PI;
if(l-- && d >= thresh)
   {
   left(dalpha);
   draw(l,d/2);
   left(dalpha); right(180);
   draw(l,d/4);
   draw(l,d/4);
   right(dalpha);
   draw(l,d/2);
   left(dalpha);
   draw(l,d/4);
   draw(l,d/4);
   right(dalpha); left(180);
   draw(l,d/2);
   right(dalpha);
   }
else forward(d);
}

/*
void test6::draw(int l, double d)
{
if(l-- && d >= thresh)
   {
   d /= 5;
   left(90);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   ward(l,d);
   ward(l,d);
   left(90);
   ward(l,d);
   ward(l,d);
   ward(l,d);
   left(90);
   ward(l,d);
   ward(l,d);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   draw(l,d);
   left(90);
   }
else forward(d);
}
*/
extern int level;

void test6::draw(int l, double d)
{
static int xxx=0;
if(l==level-1) xxx ^= 1;
if(l-- && d >= thresh)
   {
   d /= 4;
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   right(90);
   draw(l,d);
   draw(l,d);
   left(90);
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   left(90);
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   draw(l,d);
   left(90);
   draw(l,d);
   right(90);
   }
else 
   forward(d);
}
